# Abbildung 43 (Mafobuch, Grenzwertsatz)
library(ggrepel); library(EnvStats); library(ggpubr) ; library(grid)
setwd("C:/Users/Alpha/Desktop/R"); N=200000

# Normalverteilte Variable
set.seed(4321); x=rnorm(N,0,1)
n=1
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=-3,to=3)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=-3),]; Data=Data[which(Data$xq<=3),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pN1 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=3,y=0.044,parse=TRUE,label="x[i]",size=2) +
  annotate("text",x=xmin+0.5,y=0.8,parse=TRUE,label="f(x[i])",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=3.2,y=0.88) + 
  scale_x_continuous(expand=c(0,0))+scale_y_continuous(expand=c(0,0)) 
pN1
n=2
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=-3,to=3)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=-3),]; Data=Data[which(Data$xq<=3),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pN2 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=3,y=0.044,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=0.8,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=2.5,y=0.8,parse=FALSE,label="n=2",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=3.2,y=0.88) + 
  scale_x_continuous(expand=c(0,0))+scale_y_continuous(expand=c(0,0)) 
pN2
n=5
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=-3,to=3)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=-3),]; Data=Data[which(Data$xq<=3),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pN3 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=3,y=0.055,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=1,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=2.5,y=1,parse=FALSE,label="n=5",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=3.2,y=1.1) + 
  scale_x_continuous(expand=c(0,0))+scale_y_continuous(expand=c(0,0)) 
pN3
n=30
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=-3,to=3)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=-3),]; Data=Data[which(Data$xq<=3),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pN4 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=3,y=0.11,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=2,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=2.5,y=2,parse=FALSE,label="n=30",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=3.2,y=2.2) + 
  scale_x_continuous(expand=c(0,0))+scale_y_continuous(expand=c(0,0)) 
pN4

# Gleichverteilte Variable
set.seed(4321); x=runif(N,min=-2.5,max=2.5);
n=1
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=-3,to=3)); 
fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=-3),]; Data=Data[which(Data$xq<=3),]
Data$fxq=1/5
Data[which(Data$xq<=-2.5),2]=0
Data[which(Data$xq>2.5),2]=0
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pG1 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=3,y=0.044,parse=TRUE,label="x[i]",size=2) +
  annotate("text",x=xmin+0.5,y=0.8,parse=TRUE,label="f(x[i])",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=3.2,y=0.88) + 
  scale_x_continuous(expand=c(0,0))+scale_y_continuous(expand=c(0,0)) 
pG1
n=2
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=-3,to=3)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=-3),]; Data=Data[which(Data$xq<=3),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pG2 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=3,y=0.044,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=0.8,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=2.5,y=0.8,parse=FALSE,label="n=2",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=3.2,y=0.88) + 
  scale_x_continuous(expand=c(0,0))+scale_y_continuous(expand=c(0,0)) 
pG2
n=5
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=-3,to=3)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=-3),]; Data=Data[which(Data$xq<=3),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pG3 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=3,y=0.055,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=1,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=2.5,y=1,parse=FALSE,label="n=5",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=3.2,y=1.1) + 
  scale_x_continuous(expand=c(0,0))+scale_y_continuous(expand=c(0,0)) 
pG3
n=30
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=-3,to=3)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=-3),]; Data=Data[which(Data$xq<=3),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq) 
pG4 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=3,y=0.11,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=2,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=2.5,y=2,parse=FALSE,label="n=30",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=3.2,y=2.2) + 
  scale_x_continuous(expand=c(0,0))+scale_y_continuous(expand=c(0,0)) 
pG4

# Exponentialverteilte Variable
set.seed(4321); x=rexp(N)
n=1
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=0,to=6)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=0),]; Data=Data[which(Data$xq<=6),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pE1 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=6,y=0.044,parse=TRUE,label="x[i]",size=2) +
  annotate("text",x=xmin+0.5,y=0.8,parse=TRUE,label="f(x[i])",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=6.2,y=0.88) + 
  scale_x_continuous(expand=c(0,0),breaks=0:6)+scale_y_continuous(expand=c(0,0)) 
pE1
n=2
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=0,to=6)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=0),]; Data=Data[which(Data$xq<=6),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pE2 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=6,y=0.044,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=0.8,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=5.5,y=0.8,parse=FALSE,label="n=2",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=6.2,y=0.88) + 
  scale_x_continuous(expand=c(0,0),breaks=0:6)+scale_y_continuous(expand=c(0,0)) 
pE2
n=5
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=0,to=6)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=0),]; Data=Data[which(Data$xq<=6),]
min=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pE3 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=6,y=0.055,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=1,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=5.5,y=1,parse=FALSE,label="n=5",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=6.2,y=1.1) + 
  scale_x_continuous(expand=c(0,0),breaks=0:6)+scale_y_continuous(expand=c(0,0)) 
pE3
n=30
xquer=x; for (i in 1:N){xquer[i]=mean(sample(x,n))}
e=epdfPlot(xquer,density.arg.list=list(from=0,to=6)); fxq=e$f.x; xq=e$x
Data=as.data.frame(cbind(xq,fxq))
Data=Data[which(Data$xq>=0),]; Data=Data[which(Data$xq<=6),]
xmin=min(Data$xq); xmax=max(Data$xq); ymax=max(Data$fxq); ymin=min(Data$fxq)  
pE4 = ggplot(Data,aes(x=xq,y=fxq)) + 
  geom_line(aes(x=xq, y=fxq),size=0.25) + 
  theme_classic(base_size = 6) + 
  theme(axis.title.x=element_blank(),
        axis.title.y=element_blank(),
        axis.text.x = element_text(size = 6),
        axis.text.y = element_text(size = 6)) +
  annotate("text",x=6,y=0.11,parse=TRUE,label="bar(x)[k]",size=2) +
  annotate("text",x=xmin+0.5,y=2,parse=TRUE,label="f(bar(x)[k])",size=2) +
  annotate("text",x=5.5,y=2,parse=FALSE,label="n=30",size=2) +
  expand_limits(x=0,y=0)+expand_limits(x=6.2,y=2.2) + 
  scale_x_continuous(expand=c(0,0),breaks=0:6)+scale_y_continuous(expand=c(0,0)) 
pE4

pdf(file="pdf/Abb43.pdf",width=11.7/2.54, height=11.7/2.54)
ggarrange(pN1,pG1,pE1,pN2,pG2,pE2,pN3,pG3,pE3,pN4,pG4,pE4,
          ncol=3, nrow=4)
dev.off() 
