# Abbildung 80 (Mafobuch, Diskriminanzanalyse lda)
library(MASS); library(ggrepel); setwd("C:/Users/Alpha/Desktop/R")
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")

# Diskriminanzanalyse "von Hand"
A=as.matrix(Data[,c(3,2)]); y=as.factor(Data[,6]) 
A=scale(A)
n=dim(A)[1]; p=dim(A)[2]; q=2  # i=1,...,n; j=1,...,p; k=1,...,q 
aquer=colMeans(A); aquerquer=matrix(0,nrow=q,ncol=p)
for (k in 1:q){for (j in 1:p){aquerquer[k,j]=tapply(A[,j],y,mean)[k]}}
Aquer=A; Aquerquer=A
for (i in 1:n){for (j in 1:p){Aquer[i,j]=aquer[j]
    Aquerquer[i,j]=aquerquer[y[i],j]}}
A; Aquer; Aquerquer
A-Aquerquer; Aquer-Aquerquer
I=1/(n-1)*t((A-Aquerquer))%*%(A-Aquerquer)
Z=1/(n-1)*t((Aquer-Aquerquer))%*%(Aquer-Aquerquer); I;Z
Iinv=solve(I); Iinv; Iinv%*%Z; e=eigen(Iinv%*%Z); e$values[1]; e$vectors[,1]

# wie bei Bhler
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")
Data=Data[,c(6,3,2)]; Data$Marke=as.factor(Data$Marke)
Data$Einkommen=scale(Data$Einkommen); Data$Alter=scale(Data$Alter)
Amatrix=matrix(c(15.176,8.575,8.575,19.626),nrow=2); Amatrix
bvector=c(-1.482,-1.306); bvector
xvector=solve(Amatrix,bvector); xvector
laenge=sqrt(xvector[1]**2+xvector[2]**2)
xvector=1/laenge*xvector; xvector
dwert=xvector[1]*Data$Alter+xvector[2]*Data$Einkommen; dwert
cor(Data$Alter,Data$Einkommen)
cor(Data$Alter,dwert)
cor(Data$Einkommen,dwert)

# Diskriminanzanalyse mit lda
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")
Data=Data[,c(6,3,2)]; Data$Marke=as.factor(Data$Marke)
Data$Einkommen=scale(Data$Einkommen); Data$Alter=scale(Data$Alter)
fit=lda(Marke~Alter+Einkommen,data=Data); fit
pred=predict(fit,newdata=Data); table(Data$Marke,pred$class)
library(klaR)
partimat(Marke~Einkommen+Alter,data=Data,method="lda") 


Alter=fit$means[,1]; Einkommen=fit$means[,2]; 
Marke=c("bar(x)[A]","bar(x)[B]") 
Datam=data.frame(Marke,Alter,Einkommen); Datap=rbind(Data,Datam)
Datap$shape=15; Datap$shape[19:36]=16; Datap$shape[38]=16
Datap$label=Datap$Marke

# Graphische Ausgabe
alpha_a=fit$scaling[,1][1]; alpha_e=fit$scaling[,1][2]
elaenge=sqrt(alpha_a**2+alpha_e**2)
xend1=Datap$Alter[37]; yend1=Datap$Einkommen[37] # Verbindung MWs
x=(alpha_a*xend1+alpha_e*yend1)/elaenge
xanf1=alpha_a*x/elaenge; yanf1=alpha_e*x/elaenge
xend2=Datap$Alter[38]; yend2=Datap$Einkommen[38]
x=(alpha_a*xend2+alpha_e*yend2)/elaenge
xanf2=alpha_a*x/elaenge; yanf2=alpha_e*x/elaenge
xanf12=(xanf1+xanf2)/2; yanf12=(yanf1+yanf2)/2 # Klassentrenngerade
elaenge=sqrt(xanf12**2+yanf12**2)
yintercept12=elaenge**2/yanf12
slope=alpha_e/alpha_a; Datap$size=1.5
a=arrow(angle=30,length=unit(0.05,"inches"),ends="last",type="closed")

xvector[1]/xvector[2]
alpha_a; alpha_e
alpha_a/alpha_e
alpha_a/xvector[1]

pdf(file="pdf/Abb80.pdf",width=11.7/2.54, height=11.7/2.54)
ggplot(Datap,aes(Alter,Einkommen,label=label)) +
  geom_point(shape=Datap$shape,size=Datap$size) +
  geom_text_repel(parse=TRUE,size=3,box.padding=0.15,
                  point.padding=0.1) +
  theme_classic(base_size=9) +
  xlab("Alter") + ylab("Einkommen") +
  theme(axis.title.x = element_text(size=9)) +
  theme(axis.text.x = element_text(size=9)) +
  theme(axis.title.y = element_text(size=9)) + 
  theme(axis.text.y = element_text(size=9)) +
  theme(axis.line.y=element_line(color='black',size=0.25))+
  theme(axis.line.x=element_line(color='black',size=0.25))+
  theme(axis.ticks=element_line(color='black',size=0.25))+ 
  expand_limits(x=-2.5, y=-2.5) + expand_limits(x=2.5, y=2.5) + 
  scale_x_continuous(expand = c(0, 0)) + 
  scale_y_continuous(expand = c(0, 0)) +
#  geom_segment(aes(x=0,y=xvector[2],xend=xvector[1],yend=xvector[2]),linetype="longdash",size=0.25)+
#  geom_segment(aes(x=xvector[1],y=0,xend=xvector[1],yend=xvector[2]),linetype="longdash",size=0.25)+
  geom_segment(aes(x=xanf1,y=yanf1,xend=xend1,yend=yend1),linetype="longdash",size=0.25)+
  geom_segment(aes(x=xanf2,y=yanf2,xend=xend2,yend=yend2),linetype="longdash",size=0.25)+
  geom_abline(slope=slope,size=0.25) +
  geom_segment(aes(x=0,y=0,xend=xvector[1],yend=xvector[2]),linetype="solid",size=0.25,arrow=a)+
  geom_abline(intercept=yintercept12,slope=-1/slope,linetype="longdash",size=0.25) +
  annotate("text",x=xvector[1]-0.05,y=xvector[2]+0.1,parse=TRUE,
           label="hat(y)",size=3) +
  annotate("text",x=-1.7,y=xvector[2]+0.05,parse=FALSE,
           label="Diskriminanzachse",size=3) +
  annotate("text",x=-0.9,y=1.3,parse=FALSE,
           label="Trennlinie",size=3) +
  geom_hline(yintercept=0,linetype="solid",size=0.25) + geom_vline(xintercept=0,linetype="solid",size=0.25)
dev.off() 

# Multiple Diskriminanzanalyse mit lda
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")
Data=Data[,c(9,3,2)]; Data$Status=as.factor(Data$Status)
Data$Einkommen=scale(Data$Einkommen); Data$Alter=scale(Data$Alter)
fit=lda(Status~Alter+Einkommen,data=Data)
fit; pred=predict(fit,dimen=2,newdata=Data); pred$x
table(Data$Status,pred$class) # Prognose mit zwei Dimens.
pred=predict(fit,dimen=1,newdata=Data); pred$x
table(Data$Status,pred$class) # Prognose mit einer Dimens.
fit$scaling
plot(fit)
library(klaR)
partimat(Status~Alter+Einkommen,data=Data,method="lda") 

