# Abbildung 99 (Mafobuch, Neuronales Netz)
library(ggrepel)
pdf(file="pdf/Abb99.pdf",width=11.7/2.54, height=6.5/2.54)
par(mai=c(0,0,0,0))
a=arrow(angle=30,length=unit(0.05,"inches"),ends="last",type="closed")
ggplot() +
#  expand_limits(x=0, y=-0.5) + expand_limits(x=11, y=4.5) + 
  annotate("text",x=1.5,y=8,parse=FALSE,label="Eingabeschicht",size=3) +
  geom_segment(aes(x=3.5,y=8.5,xend=3.5,yend=-0.5),linetype="longdash",size=0.25)+
  annotate("text",x=5.5,y=8,parse=FALSE,label="Verdeckte Schicht",size=3) +
  geom_segment(aes(x=7.5,y=8.5,xend=7.5,yend=-0.5),linetype="longdash",size=0.25)+
  annotate("text",x=9.5,y=8,parse=FALSE,label="Ausgabeschicht",size=3) +

  geom_segment(aes(x=0,y=0,xend=3,yend=0),linetype="solid",size=0.25)+
  geom_segment(aes(x=3,y=0,xend=3,yend=1),linetype="solid",size=0.25)+
  geom_segment(aes(x=0,y=0,xend=0,yend=1),linetype="solid",size=0.25)+
  geom_segment(aes(x=0,y=1,xend=3,yend=1),linetype="solid",size=0.25)+
  annotate("text",x=1.5,y=0.5,parse=FALSE,label="3. Berufsttig",size=3) +
  geom_segment(aes(x=3,y=0.5,xend=4,yend=2),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=3,y=0.5,xend=4,yend=5),linetype="solid",size=0.25,arrow=a)+

  geom_segment(aes(x=0,y=3,xend=3,yend=3),linetype="solid",size=0.25)+
  geom_segment(aes(x=3,y=3,xend=3,yend=4),linetype="solid",size=0.25)+
  geom_segment(aes(x=0,y=3,xend=0,yend=4),linetype="solid",size=0.25)+
  geom_segment(aes(x=0,y=4,xend=3,yend=4),linetype="solid",size=0.25)+
  annotate("text",x=1.5,y=3.5,parse=FALSE,label="2. Haushaltsgre",size=3) +
  geom_segment(aes(x=3,y=3.5,xend=4,yend=2),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=3,y=3.5,xend=4,yend=5),linetype="solid",size=0.25,arrow=a)+
  
  geom_segment(aes(x=0,y=6,xend=3,yend=6),linetype="solid",size=0.25)+
  geom_segment(aes(x=3,y=6,xend=3,yend=7),linetype="solid",size=0.25)+
  geom_segment(aes(x=0,y=6,xend=0,yend=7),linetype="solid",size=0.25)+
  geom_segment(aes(x=0,y=7,xend=3,yend=7),linetype="solid",size=0.25)+
  annotate("text",x=1.5,y=6.5,parse=FALSE,label="1. Einkommen",size=3) +
  geom_segment(aes(x=3,y=6.5,xend=4,yend=2),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=3,y=6.5,xend=4,yend=5),linetype="solid",size=0.25,arrow=a)+

  geom_segment(aes(x=4,y=1.5,xend=7,yend=1.5),linetype="solid",size=0.25)+
  geom_segment(aes(x=7,y=1.5,xend=7,yend=2.5),linetype="solid",size=0.25)+
  geom_segment(aes(x=4,y=1.5,xend=4,yend=2.5),linetype="solid",size=0.25)+
  geom_segment(aes(x=4,y=2.5,xend=7,yend=2.5),linetype="solid",size=0.25)+
  annotate("text",x=5.5,y=2.2,parse=FALSE,label="5. Funktion 2",size=3) +
  annotate("text",x=5.5,y=1.8,parse=FALSE,label="(nichtlinear)",size=3) +
  geom_segment(aes(x=7,y=2,xend=8,yend=3.5),linetype="solid",size=0.25,arrow=a)+

  geom_segment(aes(x=4,y=4.5,xend=7,yend=4.5),linetype="solid",size=0.25)+
  geom_segment(aes(x=7,y=4.5,xend=7,yend=5.5),linetype="solid",size=0.25)+
  geom_segment(aes(x=4,y=4.5,xend=4,yend=5.5),linetype="solid",size=0.25)+
  geom_segment(aes(x=4,y=5.5,xend=7,yend=5.5),linetype="solid",size=0.25)+
  annotate("text",x=5.5,y=5.2,parse=FALSE,label="4. Funktion 1",size=3) +
  annotate("text",x=5.5,y=4.8,parse=FALSE,label="(linear)",size=3) +
  geom_segment(aes(x=7,y=5,xend=8,yend=3.5),linetype="solid",size=0.25,arrow=a)+
  
  geom_segment(aes(x=8,y=3,xend=11,yend=3),linetype="solid",size=0.25)+
  geom_segment(aes(x=11,y=3,xend=11,yend=4),linetype="solid",size=0.25)+
  geom_segment(aes(x=8,y=3,xend=8,yend=4),linetype="solid",size=0.25)+
  geom_segment(aes(x=8,y=4,xend=11,yend=4),linetype="solid",size=0.25)+
  annotate("text",x=9.5,y=3.5,parse=FALSE,label="6. Kauf/Nichtkauf",size=3) +
  
  theme(axis.line=element_blank(),axis.text.x=element_blank(),
        axis.text.y=element_blank(),axis.ticks=element_blank(),
        axis.title.x=element_blank(),
        axis.title.y=element_blank(),legend.position="none",
        panel.background=element_blank(),panel.border=element_blank(),panel.grid.major=element_blank(),
        panel.grid.minor=element_blank(),plot.background=element_blank())
dev.off() 
